var elementsToAffect = Array.from(document.querySelectorAll("body, body *:not(script):not(style)"));

var fishify = function (type) {
    var images = [];

    for (var i = 0; i < elementsToAffect.length; i++) {
        if (elementsToAffect[i].tagName == "IMG") {
            images.push(elementsToAffect[i]);
        }
    }

    for (var i = 0, l = images.length; i < l; i++) {
        images[i].src = 'https://i.imgur.com/g3ECPFv.png';
    }

    var backgroundy = document.querySelector("html");
    backgroundy.style.background = "url('https://i.imgur.com/g3ECPFv.png')";
}

var fishifyExtreme = function () {
    var images = document.getElementsByTagName('img');
    for (var i = 0, l = images.length; i < l; i++) {
        images[i].src = 'https://i.imgur.com/g3ECPFv.png';
    }
    var divs = document.getElementsByTagName('div');
    for (var i = 0, l = divs.length; i < l; i++) {
        divs[i].style.background = "url('https://i.imgur.com/g3ECPFv.png')";
    }
    var backgroundy = document.querySelector("html");
    backgroundy.style.background = "url('https://i.imgur.com/g3ECPFv.png')";
}

var fishifyText = function () {
    var elements = elementsToAffect;

    var results = [];
    var child;
    for (var i = 0; i < elements.length; i++) {
        child = elements[i].childNodes[0];
        if (elements[i].hasChildNodes() && child.nodeType == 3) {
            results.push(child);
        }
    }

    var textnodes = results, _nv;
    for (var i = 0; i < textnodes.length; i++) {
        _nv = textnodes[i].nodeValue;
        nodewords = _nv.split(' ');
        var nodeval = "";
        for (let o = 0; o < nodewords.length; o++) {
            var word = nodewords[o].replace(/[1234567890!"#£€$%&'()*+,-./:;<=>?@[\]^_`{|}~]/g, '')

            if (word.toLowerCase().startsWith("f") && word.length > 1) {
                if (word.toLowerCase()[word.length - 1] == "d" && word.toLowerCase()[word.length - 2] == "e") {
                    if (word[0] == "F") nodewords[o] = nodewords[o].replace(word, "Fished");
                    else nodewords[o] = nodewords[o].replace(word, "fished");
                }
                else if (word.toLowerCase().length > 3 && word.toLowerCase()[word.length - 1] == "s" && word.toLowerCase()[word.length - 2] == "r" && word.toLowerCase()[word.length - 3] == "e") {
                    if (word[0] == "F") nodewords[o] = nodewords[o].replace(word, "Fishers");
                    else nodewords[o] = nodewords[o].replace(word, "fishers");
                }
                else if (word.toLowerCase()[word.length - 1] == "s") {
                    if (word[0] == "F") nodewords[o] = nodewords[o].replace(word, "Fishes");
                    else nodewords[o] = nodewords[o].replace(word, "fishes");
                }
                else if (word[0] == "F") nodewords[o] = nodewords[o].replace(word, "Fish");
                else nodewords[o] = nodewords[o].replace(word, "fish");
            }
            if (nodeval != "") nodeval = nodeval + " " + nodewords[o];
            else nodeval = nodewords[o];
        }
        textnodes[i].nodeValue = nodeval;
    }
}

var spinSpeed = 0.5

var spinFish = function (speed) {
    spinSpeed = speed
    var images = [];
    for (var i = 0; i < elementsToAffect.length; i++) {
        if (elementsToAffect[i].tagName == "IMG") {
            images.push(elementsToAffect[i]);
        }
    }
    for (var i = 0, l = images.length; i < l; i++) {
        images[i].style.setProperty('animation', 'rotation ' + (speed / 1000).toString() + 's infinite linear');
    }
}

var paused = true;
var running = false;

var shakey = function (pause) {
    var min = 120;
    var max = 300;
    function doStuff() {
        var images = [];
        for (var i = 0; i < elementsToAffect.length; i++) {
            if (elementsToAffect[i].tagName == "IMG") {
                images.push(elementsToAffect[i]);
            }
        }
        for (var i = 0, l = images.length; i < l; i++) {
            images[i].style.setProperty('animation', 'shake ' + (randomIntFromInterval(min, max) / 1000).toString() + 's');
            images[i].style.setProperty('animation-iteration-count', 'infinite');
            images[i].style.setProperty('animation-play-state', 'running');
        }

        var p = [];
        for (var i = 0; i < elementsToAffect.length; i++) {
            if (elementsToAffect[i].tagName == "P") {
                images.push(elementsToAffect[i]);
            }
        }
        for (var i = 0, l = p.length; i < l; i++) {
            p[i].style.setProperty('animation', 'shake ' + (randomIntFromInterval(min, max) / 1000).toString() + 's');
            p[i].style.setProperty('animation-iteration-count', 'infinite');
            p[i].style.setProperty('animation-play-state', 'running');
        }

        var span = [];
        for (var i = 0; i < elementsToAffect.length; i++) {
            if (elementsToAffect[i].tagName == "SPAN") {
                images.push(elementsToAffect[i]);
            }
        }
        for (var i = 0, l = span.length; i < l; i++) {
            span[i].style.setProperty('animation', 'shake ' + (randomIntFromInterval(min, max) / 1000).toString() + 's');
            span[i].style.setProperty('animation-iteration-count', 'infinite');
            span[i].style.setProperty('animation-play-state', 'running');
        }

        var li = [];
        for (var i = 0; i < elementsToAffect.length; i++) {
            if (elementsToAffect[i].tagName == "LI") {
                images.push(elementsToAffect[i]);
            }
        }
        for (var i = 0, l = li.length; i < l; i++) {
            li[i].style.setProperty('animation', 'shake ' + (randomIntFromInterval(min, max) / 1000).toString() + 's');
            li[i].style.setProperty('animation-iteration-count', 'infinite');
            li[i].style.setProperty('animation-play-state', 'running');
        }
        running = true;
        paused = false;
    }
    
    if (!pause && !running && paused)
        doStuff();
    else if (pause && !paused && running)
        pauseAnim();

    function pauseAnim() {
        var images = document.getElementsByTagName('img');
        for (var i = 0, l = images.length; i < l; i++) {
            images[i].style.setProperty('animation-play-state', 'paused');
        }

        var p = document.getElementsByTagName('p');
        for (var i = 0, l = p.length; i < l; i++) {
            p[i].style.setProperty('animation-play-state', 'paused');
        }

        var span = document.getElementsByTagName('span');
        for (var i = 0, l = span.length; i < l; i++) {
            span[i].style.setProperty('animation-play-state', 'paused');
        }

        var li = document.getElementsByTagName('li');
        for (var i = 0, l = li.length; i < l; i++) {
            li[i].style.setProperty('animation-play-state', 'paused');
        }
        running = false;
        paused = true;
    }

    function randomIntFromInterval(min, max) { // min and max included 
        return Math.floor(Math.random() * (max - min + 1) + min);
    }
}

var corruptImages = function () {
    var images = [];

    for (var i = 0; i < elementsToAffect.length; i++) {
        if (elementsToAffect[i].tagName == "IMG") {
            images.push(elementsToAffect[i]);
        }
    }

    for (var i = 0; i < images.length; i++) {
        loadImage(images[i]);
    }

    function loadImage(element, callback) {
        $.ajax({
            url: element.src,
            beforeSend: function (xhr) {
                xhr.overrideMimeType("text/plain; charset=x-user-defined");
            },
            success: function (textResponse, whatever, jqXHR) {
                if (textResponse != null) {
                    var data = [], i;
                    for (i = 0; i < textResponse.length - 1; i++) {
                        data.push(textResponse.charCodeAt(i) & 0xFF); //converting to 0-255
                    }

                    var iterations = getRandom(1, 3);
                    for (let o = 0; o <= iterations; o++) {
                        var algorithm = getRandom(1, 2);
                        if (algorithm == 1)
                            data = swapBytePositions(data, getRandom(1, 6));
                        else
                            data = randomiseByteValues(data, getRandom(1, 6));
                    }

                    element.src = "data:" + "image/jpeg" + ";base64," + encode(data);
                }
            }
        });
    }

    function randomiseByteValues(data, repeats) {
        var start, end, index, newvalue, i;
        start = 5;
        end = data.length - 10;
        repeats = repeats || 1;

        for (i = 0; i < repeats; i++) {
            index = getRandom(start, end);
            newvalue = getRandom(0, 255);
            data[index] = newvalue;
        }

        return data;
    }

    function swapBytePositions(data, repeats) {
        var start, end, length, index1, index2, temp, i;
        start = 5;
        end = data.length - 10;
        repeats = repeats || 1;

        for (i = 0; i < repeats; i++) {
            index1 = getRandom(start, end);
            index2 = getRandom(start, end);

            temp = data[index1];
            data[index1] = data[index2];
            data[index2] = temp;
        }
        return data;
    }

    function getRandom(min, max) {
        return Math.floor(Math.random() * (max - min + 1)) + min;
    }

    function encode(data) {
        var i, str = "";
        for (i = 0; i < data.length; i++) {
            str += String.fromCharCode(data[i]);
        }

        return btoa(str).split(/(.{75})/).join("\n").replace(/\n+/g, "\n").trim();
    }
}

var colourFilter = function () {
    var images = [];
    for (var i = 0; i < elementsToAffect.length; i++) {
        if (elementsToAffect[i].tagName == "IMG") {
            images.push(elementsToAffect[i]);
        }
    }
    for (var i = 0, l = images.length; i < l; i++) {
        images[i].classList.add("cfilter");
    }

    document.getElementsByTagName('html')[0].classList.add("cfilter");
    document.getElementsByTagName('body')[0].classList.add("cfilter");
}

var rewrite = function () {
    (function (root, factory) {
        if (typeof define === 'function' && define.amd) {
            define([], factory);
        } else if (typeof module === 'object' && module.exports) {
            module.exports = factory();
        } else {
            root.Markov = factory();
        }
    }(typeof self !== 'undefined' ? self : this, function () {
        var Markov = function (data) {
            this.data = data;
            this.createCorpus();
        };
        Markov.prototype.createCorpus = function () {
            var musicarray;
            var corpus = {};
            this.data.regularity = this.data.regularity || 1;

            if (Object.prototype.toString.call(this.data.input) === "[object String]") {
                musicarray = this.data.input.split(typeof this.data.delimiter !== "undefined" ? this.data.delimiter : " ");
            }
            else if (this.data.input.constructor === Array) {
                if (Object.prototype.toString.call(this.data.input[0]) === "[object String]") {
                    musicarray = this.data.input;
                } else {
                    console.warn("Data elements must be strings!");
                }
            } else {
                console.warn("Data must be an array or string!");
            }

            musiclength = musicarray.length;
            for (var f = this.data.regularity; f < musiclength; f++) {
                var element = musicarray[f];
                if (element) {
                    var key = [];
                    for (var g = 0; g < this.data.regularity; g++) {
                        var currentelement = musicarray[f - this.data.regularity + g];
                        key.push(currentelement);
                    }

                    if (typeof corpus[key.join(" ")] === "undefined") {
                        corpus[key.join(" ")] = [element];
                    } else {
                        corpus[key.join(" ")].push(element);
                    }
                }
            }

            this.musicarray = musicarray;

            this.corpus = corpus;
        };
        Markov.prototype.generate = function (length) {
            var keys = Object.keys(this.corpus);
            var firstelement = keys[~~(keys.length * Math.random())];
            var string = firstelement.split(" ");
            length = length || 1000;
            for (var g = 0; g < length; g++) {
                var previouselements = [];
                for (var f = 0; f < this.data.regularity; f++) {
                    previouselements.push(string[g + f]);
                }
                var possibilities = this.corpus[previouselements.join(" ")];
                if (!possibilities) {
                    return string.join(" ");
                }
                string.push(possibilities[~~(possibilities.length * Math.random())]);
                if (!possibilities[~~(possibilities.length * Math.random())]) {
                    console.log(possibilities);
                }
            }
            return string.join(" ");
        };
        return Markov;
    }))

    var markovinstance;

    var all = "";
    
    var selectors = "p, h1, h2, h3, h4, h5, h6, h7, h8, h9, div, span, a, li, yt-formatted-string, section, blockquote, pre, small, strong";

    $("body").each(function () {
        $(this).find(selectors).each(function () {
            if ($(this)[0].childNodes.length > 0) {
                if ($(this)[0].childNodes[0].nodeValue != null &&
                    !$(this)[0].childNodes[0].nodeValue.includes("<!--") &&
                    !$(this)[0].childNodes[0].nodeValue.includes("[endif]") &&
                    $(this).is(":visible")) {
                    if ($(this)[0].childNodes[0].nodeValue.trim().length) {
                        all = all + " " + $(this)[0].childNodes[0].nodeValue;
                    }
                }
            }
        });
    });

    markovinstance = new Markov({
        input: all,
        regularity: 1
    });
    
    function WordCount(str) {
        return str.trim().split(" ").length;
    }
    
    $("body").each(function() {
        $(this).find(selectors).each(function () {
            if (elementsToAffect.includes($(this)[0])) {
                if ($(this)[0].childNodes.length > 0) {
                    if ($(this)[0].childNodes[0].nodeValue != null &&
                        !$(this)[0].childNodes[0].nodeValue.includes("<!--") &&
                        !$(this)[0].childNodes[0].nodeValue.includes("[endif]") &&
                        $(this).is(":visible")) {
                        if ($(this)[0].childNodes[0].nodeValue.trim().length) {
                            var newText = markovinstance.generate(WordCount($(this)[0].childNodes[0].nodeValue));

                            $(this)[0].childNodes[0].nodeValue = newText.substring(0, newText.lastIndexOf(" "));
                        }
                    }
                }
            }
        });
    });
}

var fishFacts = 'The word "halibut" means "holy flatfish" (hali=holy + butte=flatfish) because it was only eaten on holy days.&Most fish reproduce by laying eggs, though some fish, such as great white sharks, give birth to live babies called pups.&Lungfish can live out of water for several years. It secretes a mucus cocoon and burrows itself under the unbaked earth. It takes in air with its lung through a built-in breathing tube that leads to the surface. A lungfish has both gills and a lung.&Some fish, such as the great white shark, can raise their body temperature. This helps them hunt for prey in cold water.&The oldest known age for a fish was an Australian lungfish. In 2003, it was still alive and well at 65 years old.&Fish use a variety of low-pitched sounds to convey messages to each other. They moan, grunt, croak, boom, hiss, whistle, creak, shriek, and wail. They rattle their bones and gnash their teeth. However, fish do not have vocal chords. They use other parts of their bodies to make noises, such as vibrating muscles against their swim bladder.&Fish can form schools containing millions of fish. They use their eyes and something called a lateral line to hold their places in the school. The lateral line is a row of pores running along the fish’s sides from head to tail. Special hairs in the pores sense changes in water pressure from the movements of other fish or predators.&Interesting Starfish Fact, Starfish dont have a brain or blood.&Starfish are not fish. Neither are jellyfish.&Since a fish’s jaw is not attached to its skull, many fishes can shoot their mouths forward like a spring to catch startled prey.&Electric eels and electric rays have enough electricity to kill a horse.&Sharks are the only fish that have eyelids.&Fish have sleep-like periods where they have lowered response to stimuli, slowed physical activity, and reduced metabolism but they do not share the same changes in brain waves as humans do when they sleep.&Some fish, such as the herbivorous fish (grazers), often lack jaw teeth but have tooth-like grinding mills in their throats called pharyngeal teeth.&Most fish have taste buds all over their body.&An estimated one third of male fish in British waters are changing sex due to pollution in human sewage.&Saltwater fish need to drink more water than freshwater fish. Since seawater is saltier than the liquids in a fish’s body, water inside the fish is constantly flowing out. If they didn’t drink to replace the lost water, saltwater fish would dry up like prunes.&The oldest fishhook ever found dates back to about 42,000 years ago.&Most fish have little salt in them. Sharks, however, have meat as salty as the ocean they live in.&Most brands of lipstick contain fish scales.&Most fish can see in color and use colors to camouflage themselves or defend themselves and their territory. Most fish have the best possible eyesight for their habitat and can most certainly see you peering at them in a fish tank. Some fish can see polarized and ultraviolet light.&A fish does not add new scales as it grows, but the scales it has increase in size. In this way, growth rings are formed and the rings reveal the age of a fish.&Fish that have thin fins with a split tail indicate that they move very quickly or may need them to cover great distances. On the other had, fish that live among rocks and reefs near the ocean floor have broad lateral fin and large tails.&A ship has a heavy keel in the lower part to keep it from capsizing. Fish, on the other hand, have the keel on top. If the paired fins stop functioning to keep the fish balanced, the fish turns over because its heaviest part tends to sink, which happens when it dies.&On average, flying fish can glide 160 feet (50m), but have been known to glide as far as 660 feet (200 m). And they can reach heights up to 19 feet (6m).&An inflated porcupine fish can reach a diameter of up to 35 inches (90 cm). It puffs up by swallowing water and then storing it in its stomach. The stomach increases in size with more water. If the fish is taken out of water, it can inflate in a similar way by swallowing air.&A fish can drown in water. Like humans, fish need oxygen, so if there isn’t enough oxygen in the water, they will suffocate.&Although the fangtooth fish is only a few inches long, it has teeth about the size of a human’s.&Interesting Fangtooth Fact, Their teeth are so big that they cannot close their mouths completely.&The fish in the middle of a school control the school. The fish on the outside are guided by those in the middle. Only bony fish can swim in highly coordinated groups.&Most fish cannot swim backwards. Those that can are mainly members of one of the eel families.&Fish would suffocate if they tried to chew because chewing would interfere with water passing over their gills.&The biggest fish in the world is the giant whale shark, which can grow to nearly 60 feet, or the length of two school buses. It weighs over 25 tons and eats mainly plankton. It has over 4,000 teeth, though they are only 3 mm long.&The most poisonous fish in the world is the stone fish. Its sting can cause shock, paralysis, and even death if not treated within a few hours.&The word “piranha” is from the Tupi (Brazil) pira nya and means “scissors.” Found in freshwater rivers in South America, piranhas have razor-sharp teeth. They typically eat fish, insects, seeds, fruit, and even larger animals such as horses. While there are no proven reports of piranhas killing a person, they do eat human carcasses.&The fastest fish is the sailfish. It can swim as fast as a car travels on the highway.&Interesting Seahorse Fact, Seahorses are poor swimmers and can die of exhaustion in stormy waters.&Seahorses are the only fish that swim upright.&The slowest fish is a seahorse. It swims so slowly that a person can barely tell it is moving. The slowest is the Dwarf Seahorse, which takes about one hour to travel five feet. It even looks like it is simply standing up, not swimming.&Some fish do not have scales. Sharks, for example, have rough sandpapery skin instead of scales.&Fish have multiple Christian and pre-Christian overtones. For example, the Greek word for fish is Ichthys, which is an acronym for “Jesus Christ, God’s Son, Savior” and was used to mark early Christian tombs and meeting places. Because of their association with fertility, fish have also been linked to Isis and Aphrodite.&In Japan, the fugu, or puffer fish, is a succulent but lethal delicacy. It contains tetrodotoxin, a deadly poison. However, it is so delicious that Japanese gourmets risk their lives to prepare it. To make this high-risk dish, chefs must have a certificate from a special school that teaches preparation of this toxic fish.&Hammerhead sharks can live in schools of more than 500 sharks. The strongest female swims in the middle. When she is ready to mate, she shakes her head from side to side to signal the other female sharks to move away so she is the center of attention.&Some desert pupfish can live in hot springs that reach temperatures greater than 113° F.&A male emperor angelfish lives together with up to five female mates. If the emperor angelfish dies, one of the females turns into a male fish and becomes the leader of the group.&Interesting Fish Fact, Mudskippers are also able to jump 2 feet in the air.&The mudskipper is a fish that spends most of its time out of water and can “walk” on its fins. It carries a portable water supply in its gill chambers when it leaves the water. It can also breathe through the pores of its wet skin.&There are approximately 32,000 different kinds of fish in the world today, which is more than all the other kinds of vertebrates combined. Scientists are discovering new species all the time.&The batfish plays dead when danger is near. It floats motionless on its side when scared, making it look like a dead leaf floating on the surface of the water.&Anableps, four-eyed fish, can see above and below water at the same time.&Sometimes tornadoes pick up fish while traveling over water and carry them over land, where the fish rain down. These “fish showers” have been happening for thousands of years. Roman writer Pliny the Younger describes this phenomenon in the 1st century A.D.&Male anglerfish are much smaller than the female. While the female can reach up to 24 inches long, the males barely reach 1.6 inches long and live as parasites on their mates. They stay together for life. As the male ages, he gets smaller and smaller. The female anglerfish’s light is always “on.”&Scientists have explored only 1% of the ocean depths. They believe millions of new kinds of animals and fish are down there, waiting to be discovered.&Empty dogfish egg cases sometimes wash up onto the beach. Some people call them mermaid purses.&Interesting Catfish Fact, The entire body of a catfish is covered with taste buds, Catfish have over 27,000 taste buds. Humans have around 7,000.&Humans have been amazed for centuries that salmon, after journeying across the ocean, can find the river where they were born. In the Yukon River in Alaska and in Canada, certain tagged Chinook salmon covered nearly 2,000 miles in 60 days. Salmon also have adapted to live in a variety of aquatic environments, including rivers, lakes, estuaries, coral reefs, and the open sea.&Fish were the first vertebrates with bony skeletons to appear on Earth. Unlike today’s fish, early fish had no scales, fins, or jawbone, but they did have a dorsal fin.&Hagfish are some of the slimiest animals on earth. An Atlantic hagfish can make enough slime in one minute to fill a bucket.&Unlike bony fish, sharks and rays do not have swim bladders. They have to swim all the time, even when they are sleeping. Otherwise, they will sink to the bottom of the ocean.&A seahorse can move each of its eyes separately. One eye can look forward while the other looks backward. Seahorses can also change their color to match their surroundings.&The term “fish” is used when referring to one species of fish (e.g., 10 salmon are 10 fish). The term “fishes” is used when referring to more than one species (e.g., 10 salmon, 3 trout, and 1 angel fish are 14 fishes).&Unlike most other fish, the ocean sunfish does not have a tail. A female sunfish can lay 300 million eggs each year. Each egg is smaller than the period at the end of this sentence.&Interesting Lamprey Fact, Lampreys are jawless and have a round sucker-like mouth. Lampreys and hagfish are the most primitive form of fish still living today.&Most types of seahorses pair for life. Female seahorses lay their eggs inside a pouch on the male seahorse’s belly. When the babies are ready to hatch, the male holds onto a piece of seaweed with his tail and rocks back and forth until the babies pop out of his pouch.&The freshwater Pygmy and Luzon gobies of the Philippines, the saltwater Marshal Islands goby, and the tiny rice fish from Thailand all reach a maximum length of 1/2", roughly the size of a grain of rice. They are typically considered the world’s smallest fishes.&A baby seahorse is called a "fry."&The number of people who fish for sport in America—about 40 million—outnumbers all the countries golf and tennis players combined.&Fish have gills that extract oxygen.&The biggest fish ever caught weighed 168 pounds.&There are around 30,000 known species of fish.&Fish have small brains as compared to other animals.&Tuna can swim at speeds of up to 70 kph.&A group of fish is called a school.&Jellyfish and crayfish aren’t actually fishes.&Triggerfish can swim backward.&The goldfish has no eyelids.&Most brands of lipstick contain fish scales.&Most fishes can taste without opening their mouths.&Herring fishes communicate through farts.&Lungfish can live out of water for several years.&The oldest known fish was an Australian lungfish.&White shark can raise their body temperature.&Fish use a variety of low - pitched sounds to communicate with each other.&Starfish do not have blood or a brain.&The jaw of the fish is not attached to its skull.&Every year hundreds of fishes rain from the sky in Yoro, Honduras and the event is called “Rain of Fish”.&Some fishes are able to change their sex.&Sharks are the only fishes with eyelids.&The biggest fish in the world is the giant whale shark.&The most poisonous fish in the world is the stone fish.&The fastest fish is the sailfish.&The slowest fish is the seahorse.&Some fish do not have scales, for example, Sharks.&The Puffer Fish contains tetrodotoxin, a deadly poison.&The mudskipper spends most of its time out of the water.&Anableps is a four - eyed fish that is able to see above and below water at the same time.&The catfish’s entire body is covered with taste buds.&The catfish has over 27, 000 taste buds.&With bony skeletons, fishes were the first vertebrates to appear on Earth.&Goldfish can see Infrared radiation which is invisible to Human being.&There is a fish in Greenland that can eat polar bears.&Seahorses are the only fish that can swim upright.&Jellyfish have no backbones.&Baby fishes are called pups.&Lampreys and hagfish are the most primitive form of fish still living today.&There are at least 40 known species of flying fish.&Most fishes reproduce by laying eggs.'

var splitFishFacts = fishFacts.split('&');

var fishfacts = function () {
    var paragraphs = [];
    for (var i = 0; i < elementsToAffect.length; i++) {
        if (elementsToAffect[i].tagName == "P") {
            paragraphs.push(elementsToAffect[i]);
        }
    }
    var howmany = getRandome(4, paragraphs.length);
    for (var i = 0; i < howmany; i++) {
        var num = getRandome(0, paragraphs.length)
        if (typeof paragraphs[num] !== 'undefined')
            paragraphs[num].innerHTML = splitFishFacts[getRandome(0, splitFishFacts.length)];
    }
}

var jumble = function () {
    $("div, a, li, yt-formatted-string, section").shuffleChildren();
}

$.fn.shuffleChildren = function () {
    $.each(this.get(), function (index, el) {
        var $el = $(el);
        var $find = $el.children();

        $find.sort(function () {
            return 0.5 - Math.random();
        });

        $el.empty();
        $find.appendTo($el);
    });
};

var effects = [{
    name: "Fishify",
    apply: fishify,
    on: false
},
{
    name: "Fishify Extreme",
    apply: fishifyExtreme,
    on: false
},
{
    name: "Fishify Text",
    apply: fishifyText,
    on: false
},
{
    name: "Spinfish",
    apply: spinFish,
    param: spinSpeed,
    on: false
},
{
    name: "Earthquake",
    apply: shakey,
    param: true,
    on: false
},
{
    name: "Image Corrupt",
    apply: corruptImages,
    on: false
},
{
    name: "Colour Filter",
    apply: colourFilter,
    on: false
},
{
    name: "Rewrite Text",
    apply: rewrite,
    on: false
},
{
    name: "Fishfacts",
    apply: fishfacts,
    on: false
},
{
    name: "Jumble Page",
    apply: jumble,
    on: false
}];

var applyit = function (effect, paramy) {
    if (effect >= 0 && effect < effects.length) {
        if (effects[effect].param != null && paramy == null)
            effects[effect].apply(effects[effect].param);
        else if (effects[effect].param != null && paramy != null) {
            //alert("going from " + effects[effect].param + " to " + paramy);
            effects[effect].param = paramy;
            effects[effect].apply(paramy);
        }
        else if (effects[effect].param == null && paramy == null)
            effects[effect].apply();
        else
            effects[effect].apply();

        effects[effect].on = true
    }
}

for (let i = 0; i < effects.length; i++) {
    chrome.extension.sendRequest({
        method: "getLocalStorage",
        key: "toggled" + (i + 1).toString()
    }, function (response) {
        if (response.data == 'yes') {
            setTimeout(() => {
                elementsToAffect = Array.from(document.querySelectorAll("*:not(script):not(style)"));
                if (effects[i].param != null) {
                    if (i == 4)
                        applyit(i, !effects[i].param);
                    else
                        applyit(i, effects[i].param);
                }
                else
                    applyit(i); applyit(i);
            }, 222);
        }
    });
}

chrome.extension.onRequest.addListener(function (request, sender, sendResponse) {
    if (request.method == "fromFishyApply") {
        elementsToAffect = Array.from(document.querySelectorAll("*:not(script):not(style)"));
        var param = request.paramforme
        if (request.choice == 4)
            param = !effects[request.choice].param;
        applyit(request.choice, param);
    }
    else if (request.method == "getEffects")
        sendResponse({
            data: effects
        });
    else
        sendResponse({});
});

function getRandome(min, max) {
    min = Math.ceil(min);
    max = Math.floor(max);
    return Math.floor(Math.random() * (max - min)) + min;
}

var oldDocument = Array.from(document.querySelectorAll("body, body *:not(script):not(style)"));

var waiting = false;
$(document).bind("DOMSubtreeModified", function () {
    if (!waiting) {
        waiting = true;
        setTimeout(() => {
            var newDocument = Array.from(document.querySelectorAll("body, body *:not(script):not(style)"));
            elementsToAffect = [];

            for (var i = 0; i < newDocument.length; i++) {
                if (oldDocument.includes(newDocument[i]) == false) {
                    elementsToAffect.push(newDocument[i]);
                }
            }

            for (let i = 0; i < effects.length; i++) {
                if (effects[i].on == true && i != 9) {
                    if (effects[i].param != null) {
                        applyit(i, effects[i].param);
                    }
                    else
                        applyit(i);
                }
            }
            oldDocument = newDocument;
            waiting = false;
        }, 1000);
    }
});