$.fn.exists = function () {
    return this.length > 0 ? this : false;
}

var buttons = document.getElementsByClassName("fishybutton");
var buttons2 = Array.from(buttons);

var sliders = document.getElementsByClassName("slider");

var noTush;

if (document.addEventListener)
    document.addEventListener("click", handleClick, false);
else if (document.attachEvent)
    document.attachEvent("onclick", handleClick);

function handleClick(event) {
    event = event || window.event;
    event.target = event.target || event.srcElement;

    var element = event.target;

    if (element.nodeName === "BUTTON" && !noTush)
        Button(element);
}

function sendMessage(elly) {
    chrome.tabs.query({ active: true, currentWindow: true }, function (tabs) {
        var param;
        if ($(elly).find(".hideableControl").exists()) {
            param = $(elly).find(".hideableControl").find(".slider").val();
        }
        else
            param = null;

        chrome.tabs.sendRequest(tabs[0].id, {
            method: "fromFishyApply",
            paramforme: param,
            choice: buttons2.indexOf(elly.parentElement)
        });
    });
}

function Button(el) {
    noTush = true;
    if (el.classList.item(0) == "toggle") {
        if ($(el).parent().find(".button").find(".hideableText").exists() && $(el).parent().find(".button").find(".hideableControl").css("display") == "none") {
            $(el).parent().find(".button").find(".hideableText").slideUp(400, "swing");
            $(el).parent().find(".button").find(".hideableControl").slideDown(400, "swing");
        }
        var index = buttons2.indexOf(el.parentElement);
        chrome.extension.sendRequest({
            method: "getLocalStorage",
            key: "toggled" + (index + 1).toString()
        }, function (response) {
            if (response.data == 'no' || response.data == null) {
                chrome.extension.sendRequest({
                    method: "setToggled",
                    name: "toggled" + (index + 1).toString(),
                    key: 'yes'
                }, function (response) {
                    if (response.done) {
                        sendMessage(el);
                    }
                });
                el.innerHTML = "On";
                $(el).parent().addClass("on");
                $(el).css("background", "#6196b9");
            }
            else if (response.data == 'yes') {
                chrome.extension.sendRequest({
                    method: "setToggled",
                    name: "toggled" + (index + 1).toString(),
                    key: 'no'
                }, function (response) {
                    if (response.done) {
                        console.log("saved");
                    }
                });
                el.innerHTML = "Off";
                $(el).css("background", "#BEBEBE");
            }
        });
    }
    else if (el.classList.item(0) == "button") {
        if ($(el).find(".hideableText").exists() && $(el).find(".hideableControl").css("display") == "none") {
            $(el).find(".hideableText").slideUp(400, "swing");
            $(el).find(".hideableControl").slideDown(400, "swing");
        }
        $(el).parent().addClass("on");
        sendMessage(el);
    }
        
    noTush = false;
}

setValues();

function setValues() {
    for (let i = 0; i < buttons.length; i++) {
        chrome.extension.sendRequest({
            method: "getLocalStorage",
            key: "toggled" + (i + 1).toString()
        }, function (response) {
            if (response.data == 'no' || response.data == null) {
                buttons.item(i).children.item(0).innerHTML = "Off";
                $(buttons.item(i).children.item(0)).css("background", "#BEBEBE");

                if ($(buttons.item(i).children.item(1)).find(".hideableText").exists()) {
                    $(buttons.item(i).children.item(1)).find(".hideableText").slideDown(400, "swing");
                    $(buttons.item(i).children.item(1)).find(".hideableControl").slideUp(400, "swing");
                }
            }

            else if (response.data == 'yes') {
                buttons.item(i).children.item(0).innerHTML = "On";
                $(buttons.item(i)).addClass("on");
                $(buttons.item(i).children.item(0)).css("background", "#6196b9");

                if ($(buttons.item(i).children.item(1)).find(".hideableText").exists()) {
                    $(buttons.item(i).children.item(1)).find(".hideableText").slideUp(400, "swing");
                    $(buttons.item(i).children.item(1)).find(".hideableControl").slideDown(400, "swing");
                }
            }
        });
    }

    chrome.tabs.query({ active: true, currentWindow: true }, function (tabs) {
        chrome.tabs.sendRequest(tabs[0].id, {
            method: "getEffects",
        }, function (response) {
            if (response.data != null) {
                for (let i = 0; i < response.data.length; i++) {
                    if (response.data[i].on == true) {
                        $(buttons.item(i)).addClass("on");
                        if ($(buttons.item(i).children.item(1)).find(".hideableText").exists()) {
                            $(buttons.item(i).children.item(1)).find(".hideableText").slideUp(400, "swing");
                            $(buttons.item(i).children.item(1)).find(".hideableControl").slideDown(400, "swing");
                            $(buttons.item(i).children.item(1)).find(".hideableControl").find(".slider").val(response.data[i].param);
                        }
                    }
                }
            }
        });
    });

    for (let i = 0; i < sliders.length; i++) {
        sliders[i].onchange = function () {
            sendMessage(sliders[i].parentElement.parentElement);
        }
    }
}